<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkImportBase.php");
	
	/*
	 * [OBSOLETE]
		ex. : 
		<discounts for="<ref produit>" sku="<ean produit>">
			<discount from="date" to="date" solde="0/1" type="amount|percentage" tax="0/1">montant</discount>
			<discount from="date" to="date" solde="0/1" type="amount|percentage" tax="0/1">montant</discount>
			<discount from="date" to="date" solde="0/1" type="amount|percentage" tax="0/1">montant</discount>
		</discounts>
	 */
	class PolarisLinkImport_discounts extends PolarisLinkImportBase 
	{	
		// Renvoi vrai si les deux règles sont identiques
		protected function isSameSpecificPrice($price1, $price2)
		{						
			return !(($price1["id_specific_price_rule"] != $price2->id_specific_price_rule) ||
						($price1["id_shop"] != $price2->id_shop) ||
						($price1["id_shop_group"] != $price2->id_shop_group) ||
						($price1["id_currency"] != $price2->id_currency) ||
						($price1["id_country"] != $price2->id_country) ||
						($price1["id_group"] != $price2->id_group) ||
						($price1["id_customer"] != $price2->id_customer) ||
						($price1["from"] != $price2->from) ||
						($price1["to"] != $price2->to) ||
						($price1["price"] != $price2->price) ||
						($price1["from_quantity"] != $price2->from_quantity) ||			
						($price1["reduction"] != $price2->reduction) ||
						($price1["reduction_tax"] != $price2->reduction_tax) ||
						($price1["reduction_type"] != $price2->reduction_type));			
		}
		
		protected function OnImportData($data)
		{
			if (!$this->Link->OPT_ALLOW_I_PROMOS)
				return;	// Pas d'importation de promotions !
			
			// On se positionne sur le bon shop !
			$this->SetPricesContext();
			
			$product = $this->GetProductCombinationFor((string) $data["sku"], (string) $data["ean"], false, true);
			if (empty($product))
				return;		// produit inconnu

			// Chargeons les règles de prix spécifique pour ce produit
			$regles = SpecificPrice::getByProductId($product["id_product"], $product["id_product_attribute"]);
			
			// pour le produit, combinaison
			// positionné sur tout pays, toute devise, tout groupe, tout client
			// from_quantity = 1
			// pour le shop en cours...
			foreach (Shop::getContextListShopID() as $id_shop)
			{
				// Etape 1, on construit la liste à obtenir
				$prix_a_faire = array();
				foreach ($data->discount as $promo)
				{
					$spePrice = new SpecificPrice();
				
					$spePrice->id_product = $product["id_product"];
					$spePrice->id_product_attribute = $product["id_product_attribute"];
					$spePrice->id_specific_price_rule = 0;
					$spePrice->id_shop = $id_shop;
					$spePrice->id_shop_group = Shop::getGroupFromShop($id_shop);
					$spePrice->id_currency = 0;
					$spePrice->id_country = 0;
					$spePrice->id_group = 0;
					$spePrice->id_customer = 0;
					
					$spePrice->from = $this->GetDateTime((string) $promo["from"]);
					$spePrice->to = $this->GetDateTime((string) $promo["to"]);
					$spePrice->price = -1;
					$spePrice->from_quantity = 1;
					
					if (empty((string) $promo["type"]) || (string) $promo["type"] == "amount")
						$spePrice->reduction = round((float) $promo, 2);
					else
						$spePrice->reduction = round((float) $promo /(float) 100.0, 2);
					$spePrice->reduction_tax = $this->FirstNonEmpty((string) $promo["tax"], "0");
					$spePrice->reduction_type = $this->FirstNonEmpty((string) $promo["type"], "amount");
					
					// Sauvegarde
					$prix_a_faire[] = $spePrice;
				}
			
				// Ok, pour chaque élément existant, 
				// soit il existe déjà, on le laisse,
				// soit il existe pas dans ce qu'on veut créer et on l'efface
				// le tout uniquement sur des enregistrements que l'ont peut générer (positionné sur tout pays, toute devise, tout groupe, tout client, from_quantity = 1 et shop en cours)
				foreach ($regles as $regle_existante)
				{
					// On considère uniquement les éléments qui nous concerne
					if ($regle_existante["id_specific_price_rule"] != 0 ||
						$regle_existante["id_currency"] != 0 ||
						$regle_existante["id_country"] != 0 ||
						$regle_existante["id_group"] != 0 ||
						$regle_existante["id_customer"] != 0 ||
						$regle_existante["from_quantity"] != 1)
						continue;
					// Que les prix du shopid en cours
					if ($regle_existante["id_shop"] != $id_shop && $regle_existante["id_shop"] != 0)
						continue;
					
					// Sinon, est-ce que la règle existe toujours après notre passage ?				
					$found = false;
					for ($i = 0; $i < count($prix_a_faire); $i++)
					{
						if (!empty($prix_a_faire[$i]))
						{
							if ($this->isSameSpecificPrice($regle_existante, $prix_a_faire[$i]))
							{
								// Oui, on la supprime des règles à publier et on la laisse tranquille inchangée
								//var_dump($prix_a_faire[$i]);
								$prix_a_faire[$i] = null;
								$found = true;
								break;
							}						
						}
					}
					
					if (!$found)
					{
						// Sinon, c'est que cette règle est caduque
						$regle = new SpecificPrice($regle_existante["id_specific_price"]);
						$regle->delete();					
					}
				}
			
				// Ok, maintenant, création de ce qu'il reste !
				foreach ($prix_a_faire as $nouvelle_regle)
				{
					if (!empty($nouvelle_regle))
					{
						$nouvelle_regle->save();
					}
				}
			}
		}
	}
	